
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"


#define ASCIITEXTATTRIBUTES \
    XtNeditType, XawtextEdit, \
    XtNtype, XawAsciiString, \
    XtNuseStringInPlace, True, \
    XtNresizable, True, \
    XtNresize, XawtextResizeWidth, \
    XtNright, XtChainRight,


typedef struct _Text {
    char *filetext;
    char *centx, *centy, *centz;
    char *text1, *text2, *text3,
         *text4, *text5, *text6,
         *n1, *n2;
} Text, *TextPtr;


typedef struct _Widg {
    Widget cl, tp, bt;
} Widg, *WidgPtr;


typedef struct _Pass {
    TextPtr text;
    WidgPtr widg;
} Pass, *PassPtr;


void initOFFValues( ObjectValues )
ObjectStruct *ObjectValues;
{
    ObjectValues->radius = 1.0;
    ObjectValues->xaxis = 1.0;
    ObjectValues->yaxis = 1.0;
    ObjectValues->zaxis = 1.0;
    ObjectValues->length = 5.0;
    ObjectValues->depth = 3;
    ObjectValues->center.x = 0.0;
    ObjectValues->center.y = 0.0;
    ObjectValues->center.z = 0.0;
    ObjectValues->n1 = 5;
    ObjectValues->n2 = 5;
    ObjectValues->clockwise = False;
    ObjectValues->top = False;
    ObjectValues->bottom = False;
}


/*
 *   Function Name: getOFFValues
 *   Description: Creates and pops up the Dialog widget to ask for a new
 *                input values
 *   Arguments: w - the command button that activated this function.
 *   Returns: none.
 */

void
getOFFValues( toplevel, ObjectSelected )
Widget toplevel;                
int ObjectSelected;
{
    ObjectStruct *ObjectValues;

    TextPtr   text;
    WidgPtr   widg;
    PassPtr   pass;

    Widget    g_popup, g_form;
    Widget    g_label0, 
              g_filelabel, g_filetext;
    Widget    g_label1, g_label2, g_label3, g_label4, g_label5, g_label6,
              g_ln1, g_ln2,
              g_label7, g_label8, g_label9;
    Widget    g_text1, g_text2, g_text3, g_text4, g_text5, g_text6, g_n1, g_n2,
              g_toggle7, g_toggle8, g_toggle9;
    Widget    g_label00, g_label01, g_label02;
    Widget    g_label000, g_label001, g_label002;
    Widget    g_centx, g_centy, g_centz;
    Widget    g_labelx, g_labely, g_labelz;
    Widget    g_ok, g_cancel;
    Widget    g_title1, g_title2;

    char   string[20];
    String buffer;
    extern String items[80];

    /* for multi line widget */
    /* char newTrans[] = "<Key>Return : newline()"; */
    /* for single line widget */
    /* char newTrans[] = "<Key>Return : activate()"; */
    char newTrans[] = "";
    XtTranslations transTable;

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    transTable = XtParseTranslationTable( newTrans );

    text = (TextPtr) malloc( sizeof (Text) );
    widg = (WidgPtr) malloc( sizeof (Widg) );
    pass = (PassPtr) malloc( sizeof (Widg) );

    ObjectValues = (ObjectStruct *) malloc( sizeof( ObjectStruct ) );
    initOFFValues( ObjectValues );

    g_popup = XtVaCreatePopupShell( "Get Values",
                                    topLevelShellWidgetClass, toplevel,
                                    NULL );

    g_form = XtVaCreateManagedWidget( "g_form", formWidgetClass, g_popup,
                                      NULL );

    sprintf( string, "Object : %s", items[ObjectSelected] );
    g_label0 = XtVaCreateManagedWidget( "g_label0", labelWidgetClass, g_form,
               XtNlabel, string,
               NULL );

    buffer = (String) malloc( 30 );
    sprintf( buffer, "%s.%d", items[ObjectSelected], getpid() );
    text->filetext = XtNewString( buffer );
    g_filelabel = XtVaCreateManagedWidget( "g_filelabel", labelWidgetClass,
                                           g_form,
                                           NULL );
    g_filetext = XtVaCreateManagedWidget( "g_filetext", asciiTextWidgetClass,
                                           g_form,
                                           ASCIITEXTATTRIBUTES
                                           XtNstring, text->filetext,
                                           XtNlength, 30,
                                           XtNwidth, 11*strlen(buffer),
                                           XtNinsertPosition, strlen(buffer),
                                           NULL );

    g_label000 = XtVaCreateManagedWidget( "g_label000", labelWidgetClass,g_form,
                                          NULL );
    g_title1 = XtVaCreateManagedWidget( "g_title1", labelWidgetClass, g_form,
                                        NULL );

    g_label00  = XtVaCreateManagedWidget( "g_label00", labelWidgetClass,
                                         g_form,
                                         NULL );
    g_labelx  = XtVaCreateManagedWidget( "g_labelx", labelWidgetClass, g_form,
                                         NULL );

    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues->center.x ); 
    text->centx = XtNewString( buffer );
    g_centx = XtVaCreateManagedWidget( "g_centx", asciiTextWidgetClass,
                                         g_form,
                                         ASCIITEXTATTRIBUTES
                                         XtNstring, text->centx,
                                         XtNlength, 5,
                                         XtNinsertPosition, strlen(text->centx),
                                         NULL );

    g_label01  = XtVaCreateManagedWidget( "g_label01", labelWidgetClass,
                                         g_form,
                                         NULL );
    g_labely  = XtVaCreateManagedWidget( "g_labely", labelWidgetClass, g_form,
                                         NULL );

    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues->center.y );
    text->centy = XtNewString( buffer );
    g_centy = XtVaCreateManagedWidget( "g_centy", asciiTextWidgetClass,
                                         g_form,
                                         ASCIITEXTATTRIBUTES
                                         XtNstring, text->centy,
                                         XtNlength, 5,
                                         XtNinsertPosition, strlen(text->centy),
                                         NULL );

    g_label02  = XtVaCreateManagedWidget( "g_label02", labelWidgetClass,
                                         g_form,
                                         NULL );
    g_labelz  = XtVaCreateManagedWidget( "g_labelz", labelWidgetClass, g_form,
                                         NULL );

    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues->center.z );
    text->centz = XtNewString( buffer );
    g_centz = XtVaCreateManagedWidget( "g_centz", asciiTextWidgetClass,
                                         g_form,
                                         ASCIITEXTATTRIBUTES
                                         XtNstring, text->centz,
                                         XtNlength, 5,
                                         XtNinsertPosition, strlen(text->centz),
                                         NULL );

    g_label1 = XtVaCreateManagedWidget( "g_label1", labelWidgetClass, g_form,
                                         XtNwidth, 10*9,
                                         NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues->depth );
    text->text1 = XtNewString( buffer );
    g_text1  = XtVaCreateManagedWidget( "g_text1", asciiTextWidgetClass, g_form,
                                         ASCIITEXTATTRIBUTES
                                         XtNstring, text->text1,
                                         XtNlength, 1,
                                         XtNinsertPosition, strlen(text->text1),
                                         NULL );
    g_label2 = XtVaCreateManagedWidget( "g_label2", labelWidgetClass, g_form,
                                         XtNwidth, 10*9,
                                         NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues->length );
    text->text2 = XtNewString( buffer );
    g_text2  = XtVaCreateManagedWidget( "g_text2", asciiTextWidgetClass, g_form,
                                         ASCIITEXTATTRIBUTES
                                         XtNstring, text->text2,
                                         XtNlength, 5,
                                         XtNinsertPosition, strlen(text->text2),
                                         NULL );
    g_label3 = XtVaCreateManagedWidget( "g_label3", labelWidgetClass, g_form,
                                         XtNwidth, 10*9,
                                         NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues->radius );
    text->text3 = XtNewString( buffer );
    g_text3  = XtVaCreateManagedWidget( "g_text3", asciiTextWidgetClass, g_form,
                                         ASCIITEXTATTRIBUTES
                                         XtNstring, text->text3,
                                         XtNlength, 5,
                                         XtNinsertPosition, strlen(text->text3),
                                         NULL );
    g_label4 = XtVaCreateManagedWidget( "g_label4", labelWidgetClass, g_form,
                                         XtNwidth, 10*9,
                                         NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues->xaxis );
    text->text4 = XtNewString( buffer );
    g_text4  = XtVaCreateManagedWidget( "g_text4", asciiTextWidgetClass, g_form,
                                         ASCIITEXTATTRIBUTES
                                         XtNstring, text->text4,
                                         XtNlength, 5,
                                         XtNinsertPosition, strlen(text->text4),
                                         NULL );
    g_label5 = XtVaCreateManagedWidget( "g_label5", labelWidgetClass, g_form,
                                         XtNwidth, 10*9,
                                         NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues->yaxis );
    text->text5 = XtNewString( buffer );
    g_text5  = XtVaCreateManagedWidget( "g_text5", asciiTextWidgetClass, g_form,
                                         ASCIITEXTATTRIBUTES
                                         XtNstring, text->text5,
                                         XtNlength, 5,
                                         XtNinsertPosition, strlen(text->text5),
                                         NULL );
    g_label6 = XtVaCreateManagedWidget( "g_label6", labelWidgetClass, g_form,
                                         XtNwidth, 10*9,
                                         NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues->zaxis );
    text->text6 = XtNewString( buffer );
    g_text6  = XtVaCreateManagedWidget( "g_text6", asciiTextWidgetClass, g_form,
                                         ASCIITEXTATTRIBUTES
                                         XtNstring, text->text6,
                                         XtNlength, 5,
                                         XtNinsertPosition, strlen(text->text6),
                                         NULL );

    g_ln1 = XtVaCreateManagedWidget( "g_ln1", labelWidgetClass, g_form,
                                     XtNwidth, 10*9,
                                     NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues->n1 );
    text->n1 = XtNewString( buffer );
    g_n1  = XtVaCreateManagedWidget( "g_n1", asciiTextWidgetClass, g_form,
                                     ASCIITEXTATTRIBUTES
                                     XtNstring, text->n1,
                                     XtNlength, 2,
                                     XtNinsertPosition, strlen(text->n1),
                                     NULL );

    g_ln2 = XtVaCreateManagedWidget( "g_ln2", labelWidgetClass, g_form,
                                     XtNwidth, 10*9,
                                     NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues->n2 );
    text->n2 = XtNewString( buffer );
    g_n2  = XtVaCreateManagedWidget( "g_n2", asciiTextWidgetClass, g_form,
                                     ASCIITEXTATTRIBUTES
                                     XtNstring, text->n2,
                                     XtNlength, 2,
                                     XtNinsertPosition, strlen(text->n2),
                                     NULL );

    g_label001 = XtVaCreateManagedWidget( "g_label001", labelWidgetClass,g_form,
                                          NULL );

    g_title2 = XtVaCreateManagedWidget( "g_title2", labelWidgetClass, g_form,
                                         NULL );
    g_label7 = XtVaCreateManagedWidget( "g_label7", labelWidgetClass, g_form,
                                         NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle7  = XtVaCreateManagedWidget( "g_toggle7", toggleWidgetClass,g_form,
                                         XtNcallback, callbacks,
                                         NULL );
    if( ObjectValues->clockwise )
        XtVaSetValues( g_toggle7, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle7, XtNlabel, "-", NULL );

    g_label8 = XtVaCreateManagedWidget( "g_label8", labelWidgetClass, g_form,
                                         NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle8  = XtVaCreateManagedWidget( "g_toggle8", toggleWidgetClass,g_form,
                                         XtNcallback, callbacks,
                                         NULL );
    if( ObjectValues->top ) XtVaSetValues( g_toggle8, XtNlabel, "+", NULL );
    else                    XtVaSetValues( g_toggle8, XtNlabel, "-", NULL );

    g_label9 = XtVaCreateManagedWidget( "g_label9", labelWidgetClass, g_form,
                                         NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle9  = XtVaCreateManagedWidget( "g_toggle9", toggleWidgetClass,g_form,
                                         XtNcallback, callbacks,
                                         NULL );
    if( ObjectValues->bottom ) XtVaSetValues( g_toggle9, XtNlabel, "+", NULL );
    else                       XtVaSetValues( g_toggle9, XtNlabel, "-", NULL );

    g_label002 = XtVaCreateManagedWidget( "g_label002", labelWidgetClass,g_form,
                                          NULL );

    widg->cl = g_toggle7;
    widg->tp = g_toggle8;
    widg->bt = g_toggle9;
    pass->text = text;
    pass->widg = widg;

    callbacks[0].callback = (XtCallbackProc) readObjectValues;
    callbacks[0].closure  = (XtPointer) pass;
    g_ok = XtVaCreateManagedWidget( "g_ok", commandWidgetClass, g_form,
                                    XtNcallback, callbacks,
                                    NULL );
    
    callbacks[0].callback = (XtCallbackProc) DestroyPopupPrompt;
    callbacks[0].closure  = (XtPointer) g_popup;
    g_cancel = XtVaCreateManagedWidget( "g_cancel", commandWidgetClass, g_form,
                                        XtNcallback, callbacks,
                                        NULL );

    turnOFFsensitivity( g_label1, g_text1, g_label2, g_text2,
                        g_label3, g_text3, g_label4, g_text4,
                        g_label5, g_text5, g_label6, g_text6,
                        g_ln1, g_n1, g_ln2, g_n2,
                        g_label8, g_toggle8, g_label9, g_toggle9 );

    XtOverrideTranslations( g_text1, transTable );
    XtRealizeWidget( g_popup );
    XtPopup( g_popup, XtGrabNone );
}


void
turnOFFsensitivity( g_label1, g_text1, g_label2, g_text2, g_label3, g_text3,
                    g_label4, g_text4, g_label5, g_text5, g_label6, g_text6,
                    g_ln1, g_n1, g_ln2, g_n2,
                    g_label8, g_toggle8, g_label9, g_toggle9 )
Widget g_label1, g_text1, g_label2, g_text2,
       g_label3, g_text3, g_label4, g_text4,
       g_label5, g_text5, g_label6, g_text6,
       g_ln1, g_n1, g_ln2, g_n2,
       g_label8, g_toggle8, g_label9, g_toggle9;
{
    extern int ObjectSelected;

    if( ObjectSelected == BOX ) {
        XtSetSensitive( g_label2, False );          /* length */
        XtSetSensitive( g_text2, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );

        XtSetSensitive( g_label1, False );          /* depth */
        XtSetSensitive( g_text1, False );

        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );
    }
    else if( ObjectSelected == SPHERE ) {
        XtSetSensitive( g_label2, False );          /* length */
        XtSetSensitive( g_text2, False );

        XtSetSensitive( g_label4, False );          /* xaxis, yaxis, zaxis */
        XtSetSensitive( g_text4, False );
        XtSetSensitive( g_label5, False );
        XtSetSensitive( g_text5, False );
        XtSetSensitive( g_label6, False );
        XtSetSensitive( g_text6, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == CONE ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == CYLINDER ) {
        XtSetSensitive( g_label5, False );       /* yaxis */
        XtSetSensitive( g_text5, False );
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == ELLIPSOID ) {
        XtSetSensitive( g_label2, False );          /* length */
        XtSetSensitive( g_text2, False );
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == ELLIPTICCONE ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == ELLIPTICPARABOLOID ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == HYPERBOLICPARABOLOID ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == HYPERBOLOID_1 ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == HYPERBOLOID_2 ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == TORUS ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );

        XtSetSensitive( g_ln1, False );          /* n1, n2 */
        XtSetSensitive( g_n1, False );
        XtSetSensitive( g_ln2, False );
        XtSetSensitive( g_n2, False );
    }
    else if( ObjectSelected == SUPERELLIPSOID ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );
    }
    else if( ObjectSelected == SUPERHYPERBOLOID_1 ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );
    }
    else if( ObjectSelected == SUPERTORUS ) {
        XtSetSensitive( g_label3, False );          /* radius */
        XtSetSensitive( g_text3, False );

        XtSetSensitive( g_label8, False );          /* top bottom of cylinder */
        XtSetSensitive( g_toggle8, False );
        XtSetSensitive( g_label9, False );
        XtSetSensitive( g_toggle9, False );
    }
}


static void
changeSign( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Boolean state;

    XtVaGetValues( widget, XtNstate, &state, NULL );
    if( state ) XtVaSetValues( widget, XtNlabel, "+", NULL );
    if( !state ) XtVaSetValues( widget, XtNlabel, "-", NULL );
}


static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Widget popup = (Widget)client_data;
    extern char creatingObject;
    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}
