
#include "unix.h"
#include "color.h"
#include "xpex.h"

PEXColorSpecifier colorSpec;

void printColor()
{
    extern RGBf rgbf_values;
    extern HSV hsv_values;
    extern HLS hls_values;
    extern CIE cie_values;

    switch( colorSpec.type ) {
        case PEXColorTypeRGB :
            colorSpec.value.rgb.red = rgbf_values.r;
            colorSpec.value.rgb.green = rgbf_values.g;
            colorSpec.value.rgb.blue = rgbf_values.b;
            fprintf( stdout, "RGB %f %f %f\n",
                    colorSpec.value.rgb.red,
                    colorSpec.value.rgb.green,
                    colorSpec.value.rgb.blue );
            break;
        case PEXColorTypeHSV :
            colorSpec.value.hsv.hue = hsv_values.h;
            colorSpec.value.hsv.saturation = hsv_values.s;
            colorSpec.value.hsv.value = hsv_values.v;
            fprintf( stdout, "HSV %f %f %f\n",
                    colorSpec.value.hsv.hue,
                    colorSpec.value.hsv.saturation,
                    colorSpec.value.hsv.value );
            break;
        case PEXColorTypeHLS :
            colorSpec.value.hls.hue = hls_values.h;
            colorSpec.value.hls.lightness = hls_values.l;
            colorSpec.value.hls.saturation = hls_values.s;
            fprintf( stdout, "HLS %f %f %f\n",
                    colorSpec.value.hls.hue,
                    colorSpec.value.hls.lightness,
                    colorSpec.value.hls.saturation );
            break;
        case PEXColorTypeCIE :
            colorSpec.value.cie.x = cie_values.X / 255.;
            colorSpec.value.cie.y = cie_values.Y / 255.;
            colorSpec.value.cie.z = cie_values.Z / 255.;
            fprintf( stdout, "CIE %f %f %f\n",
                    colorSpec.value.cie.x,
                    colorSpec.value.cie.y,
                    colorSpec.value.cie.z );
            break;
        default :
            break;
    }
}
