
#include <X11/PEX5/PEXlib.h>

/*
 * INPUT and OUTPUT are defined to make looking at function arguments easier.
 */

#define INPUT
#define OUTPUT

#define PEXXPlane	1
#define PEXYPlane	2
#define PEXZPlane	3

Status
PEXUmbraMatrix (plane, position, light, matrixReturn)

INPUT int       	plane;
INPUT float       	position;
INPUT PEXCoord4D	light;
OUTPUT PEXMatrix	matrixReturn;

{
    switch (plane)
    {
        case PEXXPlane:
            matrixReturn[0][0] = 0.;
            matrixReturn[0][1] = 0.;
            matrixReturn[0][2] = 0.;
            matrixReturn[0][3] = position;

            matrixReturn[1][0] = light.y / -light.x;
            matrixReturn[1][1] = 1.;
            matrixReturn[1][2] = 0.;
            matrixReturn[1][3] = 0.;

            matrixReturn[2][0] = light.z / -light.x;
            matrixReturn[2][1] = 0.;
            matrixReturn[2][2] = 1.;
            matrixReturn[2][3] = 0.;

            matrixReturn[3][0] = -light.w;
            matrixReturn[3][1] = 0.;
            matrixReturn[3][2] = 0.;
            matrixReturn[3][3] = 1.;
            break;

        case PEXYPlane:
            matrixReturn[0][0] = 1.;
            matrixReturn[0][1] = light.x / -light.y;
            matrixReturn[0][2] = 0.;
            matrixReturn[0][3] = 0.;

            matrixReturn[1][0] = 0.;
            matrixReturn[1][1] = 0.;
            matrixReturn[1][2] = 0.;
            matrixReturn[1][3] = position;

            matrixReturn[2][0] = 0.;
            matrixReturn[2][1] = light.z / -light.y;
            matrixReturn[2][2] = 1.;
            matrixReturn[2][3] = 0.;

            matrixReturn[3][0] = 0.;
            matrixReturn[3][1] = -light.w;
            matrixReturn[3][2] = 0.;
            matrixReturn[3][3] = 1.;
            break;

        case PEXZPlane:
            matrixReturn[0][0] = 1.;
            matrixReturn[0][1] = 0.;
            matrixReturn[0][2] = light.x / -light.z;
            matrixReturn[0][3] = 0.;

            matrixReturn[1][0] = 0.;
            matrixReturn[1][1] = 1.;
            matrixReturn[1][2] = light.y / -light.z;
            matrixReturn[1][3] = 0.;

            matrixReturn[2][0] = 0.;
            matrixReturn[2][1] = 0.;
            matrixReturn[2][2] = 0.;
            matrixReturn[2][3] = position;

            matrixReturn[3][0] = 0.;
            matrixReturn[3][1] = 0.;
            matrixReturn[3][2] = -light.w;
            matrixReturn[3][3] = 1.;
            break;

        default:
            return (1); /* error - invalid Plane specifier */
    }

    return (Success);
}


#if( 0 ) 

        for( i=0; i<4; i++ ) {

            if( lights[i].type == PEXLightAmbient ) continue;

            for( j=0; j<4; j++ ) {
                if( lightsON[j] == i+1 ) {

                    if( lights[i].type == PEXLightWCVector ) {
                        light.x = -lights[i].direction.x;
                        light.y = -lights[i].direction.y;
                        light.z = -lights[i].direction.z;
                    }
                    if( lights[i].type == PEXLightWCPoint ) {
                        light.x = lights[i].point.x;
                        light.y = lights[i].point.y;
                        light.z = lights[i].point.z;
                    }
                    if( lights[i].type == PEXLightWCSpot ) {
                        light.x = lights[i].point.x;
                        light.y = lights[i].point.y;
                        light.z = lights[i].point.z;
                    }
                    light.w = PEXLightInfinite;

                    PEXUmbraMatrix( PEXYPlane, light, matrix );
                    PEXSetLocalTransform( display, object_shadow, PEXOCStore,
                        PEXReplace, matrix );
                    PEXFillAreaWithData( display, object_shadow, PEXOCStore,
                        PEXShapeConvex, PEXFalse,
                        PEXGANone, PEXGANone,
                        PEXColorTypeRGB,
                        &facet_data[k],
                        vertex_data[k].count, vertex_data[k].vertices );
                }
            }
        }

#endif		/*  */
